function BasicWIHActionClient()
{
	this.version = 12.1;
	this.basicWIH = null;
	this.initBasicWIHActionObject = BasicWIHActionClient_initBasicWIHActionObject;
	this.doAction = BasicWIHActionClient_doAction;
	this.getBasicWIHActionObject = function(){this.initBasicWIHActionObject();return this.basicWIH;};

	this.setContinueOption = function(option){this.initBasicWIHActionObject();return this.basicWIH.setContinueOption(option);};
	this.getContinueOption = function(){this.initBasicWIHActionObject();return this.basicWIH.getContinueOption();};
	this.setContinue = function(){this.initBasicWIHActionObject();return this.basicWIH.setContinue();};
	this.setStop = function(){this.initBasicWIHActionObject();return this.basicWIH.setStop();};
	this.setWait = function(){this.initBasicWIHActionObject();return this.basicWIH.setWait();};

	this.complete = function(){this.initBasicWIHActionObject();return this.basicWIH.complete();};
	this.save = function(){this.initBasicWIHActionObject();return this.basicWIH.save();};
	this.monitor = function(){this.initBasicWIHActionObject();return this.basicWIH.monitor();};
	this.comment = function(){this.initBasicWIHActionObject();return this.basicWIH.comment();};
	this.attach = function(){this.initBasicWIHActionObject();return this.basicWIH.attach();};
	this.edmsAttach = function(){this.initBasicWIHActionObject();return this.basicWIH.edmsAttach();};
	this.adHoc = function(){this.initBasicWIHActionObject();return this.basicWIH.adHoc();};
	this.exit = function(){this.initBasicWIHActionObject();return this.basicWIH.exit();};
	this.generalInfo = function(){this.initBasicWIHActionObject();return this.basicWIH.generalInfo();};
	this.selectNextUser = function(){this.initBasicWIHActionObject();return this.basicWIH.selectNextUser();};
	this.selectNextApplication = function(){this.initBasicWIHActionObject();return this.basicWIH.selectNextApplication();};
	this.reply = function(){this.initBasicWIHActionObject();return this.basicWIH.reply();};
	this.forward = function(){this.initBasicWIHActionObject();return this.basicWIH.forward();};
	this.respond = function(responseName){this.initBasicWIHActionObject();return this.basicWIH.respond(responseName);}; /* responseName is optional */

	this.getResponsesInfo = function(){this.initBasicWIHActionObject();return this.basicWIH.getResponsesInfo();};
	this.setResponseByName = function(name){this.initBasicWIHActionObject();return this.basicWIH.setResponseByName(name);};
	this.getSelectedResponse = function(){this.initBasicWIHActionObject();return this.basicWIH.getSelectedResponse();};
	this.setCommentRequired = function(require){this.initBasicWIHActionObject();return this.basicWIH.setCommentRequired(require);}
	this.setReadCommentRequired = function(require){this.initBasicWIHActionObject();return this.basicWIH.setReadCommentRequired(require);};
	this.getCommentCount = function(){this.initBasicWIHActionObject();return this.basicWIH.getCommentCount();};
	this.getAttachmentInfo = function(){this.initBasicWIHActionObject();return this.basicWIH.getAttachmentInfo();};

    this.getWIHOption = function(key){this.initBasicWIHActionObject();return this.basicWIH.getWIHOption(key);};
    this.setWIHOption = function(key, value){this.initBasicWIHActionObject();return this.basicWIH.setWIHOption(key, value);};

    BasicWIHActionClient_initBasicWIHActionObject();
}

function BasicWIHActionClient_initBasicWIHActionObject()
{
	{
		if(top.parent && top.parent.getBasicWIHActionObject)
		{
			this.basicWIH = top.parent.getBasicWIHActionObject();
		}else
        {
            //in case of a modal window mode, find WIH_action frame going up to parent frame
            var obj = parent;
            while(obj)
            {
                if (obj.frames && "undefined" != typeof(obj.frames) && top != obj)
                {
                    if("undefined" != typeof(obj.getBasicWIHActionObject))
                    {
	                    this.basicWIH = obj.getBasicWIHActionObject();
	                    break;
                    }else
                    {
                        obj = obj.parent;
                    }
                }else
                {
                    break;
                }
            }
        }
    }
}

/**
 * Do action
 * @command: command
 * @param1 ~ param5: this is not mandatory. these are defined for the extension in the future
 */
function BasicWIHActionClient_doAction(command)
{
	var ret;

	if(command == this.basicWIH.ACTION_COMPLETE)ret = this.complete();
	else if(command == this.basicWIH.ACTION_SAVE) ret = this.save();
	else if(command == this.basicWIH.ACTION_MONITOR) ret = this.monitor();
	else if(command == this.basicWIH.ACTION_COMMENT) ret = this.comment();
	else if(command == this.basicWIH.ACTION_ATTACH) ret = this.attach();
	else if(command == this.basicWIH.ACTION_EDMSATTACH) ret = this.edmsAttach();
	else if(command == this.basicWIH.ACTION_ADHOC) ret = this.adHoc();
	else if(command == this.basicWIH.ACTION_EXIT) ret = this.exit();
	else if(command == this.basicWIH.ACTION_GENERALINFO) ret = this.generalInfo();
	else if(command == this.basicWIH.ACTION_SELECT_NEXT_USER) ret = this.selectNextUser();
	else if(command == this.basicWIH.ACTION_SELECT_NEXT_APPLICATION) ret = this.selectNextApplication();
	else if(command == this.basicWIH.ACTION_REPLY) ret = this.reply();
	else if(command == this.basicWIH.ACTION_FORWARD) ret = this.forward();
	else if(command == this.basicWIH.ACTION_RESPOND) ret = this.respond();

	return ret;
}

//Global Object for BasicWIHActionClient
var basicWIHActionClient = new BasicWIHActionClient();